
//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//	V.R. CONFERENCING APPLICATION                                       //
//                                                                          //
//	Written by R.M.J.Tucker                                             //
//                                                                          //
//	(C) Copyright 1996                                                  //
//                                                                          //
//	CIRCLECAM.CPP                                                       //
//                                                                          //
//	Implementation of CIRCLECAM class.                                  //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

#include "CAMERA\CIRCLCAM.H"

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Create a blank circling camera.                                          //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
				
CIRCLECAM :: CIRCLECAM ( void )

/*	PRE	:
	POST	:
*/

{
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Ready the circling camera transformation matrix.                         //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

void CIRCLECAM :: Ready ( void )

/*	PRE	:
	POST	:
*/

{
	static POINT l;

	/*	Set the initial position
		relative to the origin.	*/

	Location.v [0] = 0.0;
	Location.v [1] = 0.0;
	Location.v [2] = Distance_Z;

	/*	Increase the 
		yaw of the camera.	*/

	YawBy ( 5.0 );

	/*	Ready the basic
		camera.	*/

	CAMERA :: Ready ();

	/*	Rotate the location
		about the focus.	*/

	Transformation.Multiply ( 1, &Location, &Location );

	/*	Now move relative
		to the focus.	*/

	Location += *Focus;
	Location.v [1] += Distance_Y;

	/*	Now ready the
		tracking camera.	*/

	TRACKCAM :: Ready ();
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Set the focal point for the circling camera.                             //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

void CIRCLECAM :: SetFocus ( POINT *f, REAL Dist_Z, REAL Dist_Y )

/*	PRE	:
	POST	:
*/

{
	Focus = f;
	Distance_Z = Dist_Z;
	Distance_Y = Dist_Y;
}


