
//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//	V.R. CONFERENCING APPLICATION                                       //
//                                                                          //
//	Written by R.M.J.Tucker                                             //
//                                                                          //
//	(C) Copyright 1996                                                  //
//                                                                          //
//	TRACKCAM.CPP                                                        //
//                                                                          //
//	Implementation of TRACKCAM class.                                   //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

#include "CAMERA\TRACKCAM.H"

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Create a blank tracking camera.                                          //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
				
TRACKCAM :: TRACKCAM ( void )

/*	PRE	:
	POST	:
*/

{

}

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Ready the tracking camera transformation matrix.                         //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

void TRACKCAM :: Ready ( void )

/*	PRE	:
	POST	:
*/

{
	/*	View up vector points
		into the sky.	*/

	Up.Set ( 0.0, 100.0, 0.0 );

	/*	and the focal point
		relative to the camera.	*/

	Normal.Make ( &Location, Focus );

	/*	and the right vector
		is the cross product.	*/

	Right = Up;
	Right.Cross ( Normal );

	/*	Re-calculate the up vector 
		to take account of this.	*/

	Up = Normal;
	Up.Cross ( Right );

	/*	Now 
		unitise.	*/

	Up.Unit ();
	Right.Unit ();
	Normal.Unit ();

	/*	Plug into
		matrix.	*/

	Transformation.Compose ( Right, Up, Normal );
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Set the focal point for the tracking camera.                             //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

void TRACKCAM :: SetFocus ( POINT *f )

/*	PRE	:
	POST	:
*/

{
	Focus = f;
}


