
//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//	V.R. CONFERENCING APPLICATION                                       //
//                                                                          //
//	Written by R.M.J.Tucker                                             //
//                                                                          //
//	(C) Copyright 1996                                                  //
//                                                                          //
//	ZOOMCAM.CPP                                                        //
//                                                                          //
//	Implementation of ZOOMCAM class.                                   //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

#include "CAMERA\ZOOMCAM.H"

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Create a blank zooming camera.                                           //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
				
ZOOMCAM :: ZOOMCAM ( void )

/*	PRE	:
	POST	:
*/

{

}

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Ready the zooming camera transformation matrix.                          //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

void ZOOMCAM :: Ready ( void )

/*	PRE	:
	POST	:
*/

{
	REAL DistanceTo, Step;

	/*	Setup the tracking
		camera.	*/

	TRACKCAM :: Ready ();

	/*	Get the length of the normal
		( the distance to the focus ).	*/

	DistanceTo = Normal.Length ();

	/*	Now move the location
		towards the focus.	*/

	if ( DistanceTo > Distance ) {	
		Step = ( DistanceTo / Speed );
		Normal *= Step;
		Location += Normal;
	}
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Set the focal point for the zooming camera.                              //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

void ZOOMCAM :: SetFocus ( POINT *f, POINT *Init, REAL Dist, REAL s )

/*	PRE	:
	POST	:
*/

{
	Location = *Init;
	Focus = f;
	Distance = Dist;
	Speed = s;
}


/*

types of tracking camera

	Circling 				Focus, Distance, Speed
	Fixed 					Focus
	Chasing 				Focus, Distance
	FlyBy					Focus, Distance, Speed
*/