
//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//	V.R. CONFERENCING APPLICATION                                       //
//                                                                          //
//	Written by R.M.J.Tucker                                             //
//                                                                          //
//	(C) Copyright 1996                                                  //
//                                                                          //
//	POLYGON.CPP                                                         //
//                                                                          //
//	Implementation of POLYGON class.                                    //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
	
#include "GEOMETRY\POLYGON.H"

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Operation to set the geometric properties of this polygon.               //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

void POLYGON :: Set ( int f, int n, int *v )

/*	PRE	:	TRUE
	POST	:	Set the geometric properties of the polygon
*/

{
	Flag = f;
	Vertices = v;
	nVerts = n;
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Operation to set the colour\texture properties of this polygon.          //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

void POLYGON :: Set ( int Side, PIXEL Col, TEXTUREMAP *Tex, INTPOINT *TexCords )

/*	PRE	:	TRUE
	POST	:	Set the colour and texutre properties of the polygon
*/

{
	if ( ( Side & INSIDE ) == INSIDE ) {
		Inside.Colour = Col;
		Inside.Texture = Tex;
		Inside.TexVerts = TexCords;
	}
	if ( ( Side & OUTSIDE ) == OUTSIDE ) {
		Outside.Colour = Col;
		Outside.Texture = Tex;
		Outside.TexVerts = TexCords;
	}
}


