
//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//	V.R. CONFERENCING APPLICATION                                       //
//                                                                          //
//	Written by R.M.J.Tucker                                             //
//                                                                          //
//	(C) Copyright 1996                                                  //
//                                                                          //
//	MOUSE.H                                                             //
//                                                                          //
//	Definition of MOUSE class.                                          //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
	
#if !defined ( __MOUSE__ )
	#define __MOUSE__

	#include <dos.h>

	#include "GLOBAL\TYPES.H"

	class MOUSE {

		private :

			int x, y, dx, dy;

		public :

			/*	Constructor to
				initialise the mouse.	*/

			MOUSE ( void );

			/*	Initialise the
				mouse.	*/

			void Initialise ( void );

			/*	Reset the
				mouse.	*/

			void Reset ( void );

			/*	Switch the mouse
				pointer to on.	*/

			void On ( void );

			/*	Switch the mouse
				pointer to off.	*/

			void Off ( void );

			/*	Set the position
				of the mouse.	*/

			void SetPosition ( int x, int y );

			/*	Return the difference
				in movement of the mouse.	*/

			void GetMovement ( int *x, int *y );

			/*	Return the position
				of the mouse.	*/

			int  GetPosition ( int *x, int *y );

			/*	Return the button
				status of the mouse.	*/

			int  GetButtons  ( void );
	};
#endif