
//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//	V.R. CONFERENCING APPLICATION                                       //
//                                                                          //
//	Written by R.M.J.Tucker                                             //
//                                                                          //
//	(C) Copyright 1996                                                  //
//                                                                          //
//	POINT.H                                                             //
//                                                                          //
//	Definition of POINT class.                                          //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
	
#if !defined ( __POINT__ )
	#define __POINT__

	#include "GLOBAL\TYPES.H"

	/*	Describe the
		point class.	*/

	class POINT {

		public :

			/*	A point is simply
				3 real values.	*/

			REAL v [3];

			/*	Default point	
				initialiser does nout.	*/

			POINT ( void );

			/*	Initialise a point	
				on the command line.	*/

			POINT ( REAL x, REAL y, REAL z );

			/*	Initialise a point
				with another point.	*/

			POINT ( POINT& Point );

			/*	Make one point equal
				another.	*/

			POINT& operator = ( POINT& Point );

			/*	Explicit setting of
				a point.	*/

			void Set ( REAL x, REAL y, REAL z );

			/*	Subtract a point
				from this point.	*/

			POINT& operator -= ( POINT& Point );

			/*	Add a point
				to this point.	*/

			POINT& operator += ( POINT& Point );

			/*	Divide a point
				through.	*/

			POINT& operator /= ( REAL Value );

			/*	Multiply by
				a point.	*/

			POINT& operator *= ( REAL Value );

			/*	Apply perspective
				to a point.	*/

			void Perspective ( void );
	};
#endif