



#include "MODE\MODE.H"

#include <string.h>
#include <ctype.h>

typedef struct {

	PIXEL Maps [8];

} FONTLETTER;

#define FONTMAP(a,b,c,d,e,f,g,h) (a*16)+(b*32)+(c*64)+(d*128)+(e*1)+(f*2)+(g*4)+(h*8)

static FONTLETTER Letters [26] = {
	{	FONTMAP ( 0, 0, 0, 1, 0, 0, 0, 0 ),
		FONTMAP ( 0, 0, 1, 0, 1, 0, 0, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 1, 0, 0 ),
		FONTMAP ( 1, 1, 1, 1, 1, 1, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 0, 0, 0 )
	},
	{	FONTMAP ( 1, 1, 1, 1, 1, 1, 0, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 0, 1 ,0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 0, 1, 1, 1, 1, 1, 0, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 1, 1, 1, 1, 1, 0, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 0, 0, 0 )
	},
	{	FONTMAP ( 0, 0, 1, 1, 1, 1, 0, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 0, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 0, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 0, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 0, 0, 1, 1, 1, 1, 0, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 0, 0, 0 )
	},
	{	FONTMAP ( 1, 1, 1, 1, 1, 0, 0, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 1, 0 ,0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 1, 0, 0 ),
		FONTMAP ( 1, 1, 1, 1, 1, 0, 0, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 0, 0, 0 )
	},
	{	FONTMAP ( 1, 1, 1, 1, 1, 1, 0, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 0, 0, 0 ),
		FONTMAP ( 0, 1, 1, 1, 1, 0, 0, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 0, 0, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 1, 1, 1, 1, 1, 0, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 0, 0, 0 )
	},
	{	FONTMAP ( 1, 1, 1, 1, 1, 1, 0, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 0, 1 ,0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 0, 0, 0 ),
		FONTMAP ( 0, 1, 1, 1, 1, 0, 0, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 0, 0, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 0, 0, 0 ),
		FONTMAP ( 1, 1, 0, 0, 0, 0, 0, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 0, 0, 0 )
	},
	{	FONTMAP ( 0, 0, 1, 1, 1, 1, 0, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 0, 0 ),
		FONTMAP ( 1, 0, 1, 1, 1, 1, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 0, 0, 1, 1, 1, 1, 0, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 0, 0, 0 )
	},
	{	FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1 ,0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 1, 1, 1, 1, 1, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 0, 0, 0 )
	},
	{	FONTMAP ( 1, 1, 1, 1, 1, 1, 1, 0 ),
		FONTMAP ( 0, 0, 0, 1, 0, 0, 0 ,0 ),
		FONTMAP ( 0, 0, 0, 1, 0, 0, 0, 0 ),
		FONTMAP ( 0, 0, 0, 1, 0, 0, 0, 0 ),
		FONTMAP ( 0, 0, 0, 1, 0, 0, 0, 0 ),
		FONTMAP ( 0, 0, 0, 1, 0, 0, 0, 0 ),
		FONTMAP ( 1, 1, 1, 1, 1, 1, 1, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 0, 0, 0 )
	},
	{	FONTMAP ( 1, 1, 1, 1, 1, 1, 1, 0 ),
		FONTMAP ( 0, 0, 0, 1, 0, 0, 0, 0 ),
		FONTMAP ( 0, 0, 0, 1, 0, 0, 0, 0 ),
		FONTMAP ( 0, 0, 0, 1, 0, 0, 0, 0 ),
		FONTMAP ( 1, 0, 0, 1, 0, 0, 0, 0 ),
		FONTMAP ( 1, 0, 0, 1, 0, 0, 0, 0 ),
		FONTMAP ( 0, 1, 1, 0, 0, 0, 0, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 0, 0, 0 )
	},
	{	FONTMAP ( 1, 0, 0, 0, 1, 1, 0, 0 ),
		FONTMAP ( 1, 0, 0, 1, 0, 0, 0 ,0 ),
		FONTMAP ( 1, 0, 1, 0, 0, 0, 0, 0 ),
		FONTMAP ( 1, 1, 0, 0, 0, 0, 0, 0 ),
		FONTMAP ( 1, 0, 1, 0, 0, 0, 0, 0 ),
		FONTMAP ( 1, 0, 0, 1, 0, 0, 0, 0 ),
		FONTMAP ( 1, 0, 0, 0, 1, 1, 0, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 0, 0, 0 )
	},
	{	FONTMAP ( 1, 0, 0, 0, 0, 0, 0, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 0 ,0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 0, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 0, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 0, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 0, 0 ),
		FONTMAP ( 1, 1, 1, 1, 1, 1, 1, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 0, 0, 0 )
	},
	{	FONTMAP ( 1, 1, 0, 0, 0, 1, 1, 0 ),
		FONTMAP ( 1, 0, 1, 0, 1, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 1, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 1, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 0, 0, 0 )
	},
	{	FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 1, 0, 0, 0, 0, 1 ,0 ),
		FONTMAP ( 1, 0, 1, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 1, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 1, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 1, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 0, 0, 0 )
	},
	{	FONTMAP ( 0, 1, 1, 1, 1, 1, 0, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1 ,0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 0, 1, 1, 1, 1, 1, 0, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 0, 0, 0 )
	},
	{	FONTMAP ( 1, 1, 1, 1, 1, 1, 0, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 0, 1, 1, 1, 1, 1, 0, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 0, 0, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 0, 0, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 0, 0, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 0, 0, 0 )
	},
	{	FONTMAP ( 0, 1, 1, 1, 1, 1, 0, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1 ,0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 1, 1, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 1, 1, 0, 0 ),
		FONTMAP ( 0, 1, 1, 1, 0, 1, 1, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 0, 0, 0 )
	},
	{	FONTMAP ( 1, 1, 1, 1, 1, 1, 0, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 1, 1, 1, 1, 1, 0, 0 ),
		FONTMAP ( 1, 0, 0, 1, 0, 0, 0, 0 ),
		FONTMAP ( 1, 0, 0, 0, 1, 0, 0, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 1, 1, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 0, 0, 0 )
	},
	{	FONTMAP ( 0, 1, 1, 1, 1, 1, 0, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 0, 0 ),
		FONTMAP ( 0, 1, 1, 1, 1, 1, 0, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 0, 1, 1, 1, 1, 1, 0, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 0, 0, 0 )
	},
	{	FONTMAP ( 1, 1, 1, 1, 1, 1, 1, 0 ),
		FONTMAP ( 0, 0, 0, 1, 0, 0, 0 ,0 ),
		FONTMAP ( 0, 0, 0, 1, 0, 0, 0, 0 ),
		FONTMAP ( 0, 0, 0, 1, 0, 0, 0, 0 ),
		FONTMAP ( 0, 0, 0, 1, 0, 0, 0, 0 ),
		FONTMAP ( 0, 0, 0, 1, 0, 0, 0, 0 ),
		FONTMAP ( 0, 0, 0, 1, 0, 0, 0, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 0, 0, 0 )
	},
	{	FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 0, 1, 1, 1, 1, 1, 0, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 0, 0, 0 )
	},
	{	FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 1, 0, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 1, 0, 0 ),
		FONTMAP ( 0, 0, 1, 0, 1, 0, 0, 0 ),
		FONTMAP ( 0, 0, 0, 1, 0, 0, 0, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 0, 0, 0 )
	},
	{	FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1 ,0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 0, 1, 0, 0, 1, 0 ),
		FONTMAP ( 1, 0, 1, 0, 1, 0, 1, 0 ),
		FONTMAP ( 1, 1, 0, 0, 0, 1, 1, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 0, 0, 0 )
	},
	{	FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 1, 0 ,0 ),
		FONTMAP ( 0, 0, 1, 0, 1, 0, 0, 0 ),
		FONTMAP ( 0, 0, 0, 1, 0, 0, 0, 0 ),
		FONTMAP ( 0, 0, 1, 0, 1, 0, 0, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 1, 0, 0 ),
		FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 0, 0, 0 )
	},
	{	FONTMAP ( 1, 0, 0, 0, 0, 0, 1, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 1, 0, 0 ),
		FONTMAP ( 0, 0, 1, 0, 1, 0, 0, 0 ),
		FONTMAP ( 0, 0, 0, 1, 0, 0, 0, 0 ),
		FONTMAP ( 0, 0, 0, 1, 0, 0, 0, 0 ),
		FONTMAP ( 0, 0, 0, 1, 0, 0, 0, 0 ),
		FONTMAP ( 0, 0, 0, 1, 0, 0, 0, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 0, 0, 0 )
	},
	{	FONTMAP ( 1, 1, 1, 1, 1, 1, 1, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 1, 0, 0 ),
		FONTMAP ( 0, 0, 0, 0, 1, 0, 0, 0 ),
		FONTMAP ( 0, 0, 0, 1, 0, 0, 0, 0 ),
		FONTMAP ( 0, 0, 1, 0, 0, 0, 0, 0 ),
		FONTMAP ( 0, 1, 0, 0, 0, 0, 0, 0 ),
		FONTMAP ( 1, 1, 1, 1, 1, 1, 1, 0 ),
		FONTMAP ( 0, 0, 0, 0, 0, 0, 0, 0 )
	}
};

void GRAPHICSMODE :: OutText ( int x, int y, char *String, PIXEL Foreground, PIXEL Background )

/*	PRE	:
	POST	:
*/

{
	int	i, j;
	PIXEL	*Screen, *ptr, Map;
	char	Character;

	/*	Get the address
		of the screen.	*/

	Screen = GETADDRESS ( x, y );

	/*	Now for each
		letter.	*/

	for ( j = 0; j < strlen ( String ); j++ ) {

		/*	Use temporary
			screen pointer.	*/

		ptr = Screen;
		Character = String [j];
		if ( Character == ' ' ) {
			Screen += 2;
			continue;
		}

		Character -= 65;

		/*	Blitter first the
			left and then right.	*/

		 for ( i = 0; i < 8; i++ ) {
			Map = Letters [Character].Maps [i] >> 4;
			MAPMASK ( Map );
			*ptr = Foreground;
			MAPMASK ( 255 - Map );
			*ptr = Background;
			Map = ( Letters [Character].Maps [i] & 0xF );
			MAPMASK ( Map );
			*( ptr + 1 ) = Foreground;
			MAPMASK ( 255 - Map );
			*( ptr + 1 ) = Background;
			ptr += 80;
		}

		Screen += 2;
	}
}

void GRAPHICSMODE :: OutText ( int x, int y, char *String, PIXEL Foreground )

/*	PRE	:
	POST	:
*/

{
	int	i, j;
	PIXEL	*Screen, *ptr, Map;
	char	Character;

	/*	Get the address
		of the screen.	*/

	Screen = GETADDRESS ( x, y );

	/*	Now for each
		letter.	*/

	for ( j = 0; j < strlen ( String ); j++ ) {

		/*	Use temporary
			screen pointer.	*/

		ptr = Screen;
		Character = String [j];
		if ( Character == ' ' ) {
			Screen += 2;
			continue;
		}

		Character -= 65;

		/*	Blitter first the
			left and then right.	*/

		for ( i = 0; i < 8; i++ ) {
			Map = Letters [Character].Maps [i] >> 4;
			MAPMASK ( Map );
			*ptr = Foreground;
			Map = ( Letters [Character].Maps [i] & 0xF );
			MAPMASK ( Map );
			*( ptr + 1 ) = Foreground;
			ptr += 80;
		}

		Screen += 2;
	}
}