
//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//	V.R. CONFERENCING APPLICATION                                       //
//                                                                          //
//	Written by R.M.J.Tucker                                             //
//                                                                          //
//	(C) Copyright 1996                                                  //
//                                                                          //
//	MODELINE.CPP                                                        //
//                                                                          //
//	Implementation of MODE class.                                       //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
	
#include "MODE\MODE.H"

#include <dos.h>
#include <mem.h>

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Draw a horizontal line onto the page.                                    //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

void GRAPHICSMODE :: hLine ( int x1, int x2, int y, PIXEL Colour )

/*	PRE	:	TRUE
	POST	:	Render a line onto the page
*/

{
	OverScan ( x1, x2, y, Colour );
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Draw a vertical line onto the page.                                      //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

void GRAPHICSMODE :: vLine ( int x, int y1, int y2, PIXEL Colour )

/*	PRE	:	TRUE
	POST	:	Render a line onto the page
*/

{
	PIXEL *Address;

	/*	Always render from
		top downwards.	*/

	if ( y1 > y2 ) {
		SWAP ( y1, y2 );
	}

	/*	And blitter the	line directly
		to the screen.	*/

	Address = GETADDRESS ( x, y1 );

	/*	For this plane
		number.	*/

	SELECTPAGE ( x );

	for ( ; y1 <= y2; y1++ ) {
		*Address = Colour;
		Address += Width;
	}
}
