

.MODEL HUGE


.386


.DATA
	_ASM_Ptr	dd	?
	_ASM_SourceX	dd	?
	_ASM_SourceY	dd	?
	_ASM_Tex	dd	?
	_ASM_StepX	dd	?
	_ASM_StepY	dd	?
	_ASM_Colour	db	?
	_ASM_TexWidth	db	?
	_ASM_Length	dw	?
	Off		dw	?

.CODE

_ASM_TexScanLine	PROC	FAR

;	for (; DestX < DestXMax; DestX++ ) {
;		Pix = * ( TexMapBits + ( int ) ( SourceX >> 16 ) + ( ( int ) ( SourceY >> 16 ) << TexMapDeltaY ) );
;		*Ptr = ( Pix + tColour );
;		SourceX += SourceXStep;
;		SourceY += SourceYStep;
;		Ptr += 80;
;	}

	push	BP
	push	DS
	push	SI
	push	DI
	push	BX
	push	CX

	mov	AX, seg _ASM_Tex
	mov	DS, AX
	lgs	SI, _ASM_Ptr		; GS:SI = screen
	lfs	DI, _ASM_Tex		; FS:DI = Texture map
	mov	Off, DI
	mov	BP, _ASM_Length		; BP = Loop counter
	mov	CL, _ASM_TexWidth	; CL = Tex map log 2n
	mov	CH, _ASM_Colour		; CH = colour of map
	mov	EDI, _ASM_StepX
	mov	EDX, _ASM_StepY

texloop :

	mov	EBX, _ASM_SourceX	; Normalise the X pointer
	shr	EBX, 16
	mov	EAX, _ASM_SourceY	; Normalise the Y pointer
	shr	EAX, 16
	shl	AX, CL			; Now back into Y map position
	add	BX, AX			; Use BX to index texture
	add	BX, Off			; Offset the screen of course
	mov	AL, CH
	add	AL, FS:[BX]		; Get the texture point
	mov 	GS:[SI], AL		; write the pixel
	add	SI, 80			; Go to the next pixel
	add	_ASM_SourceX, EDI
	add	_ASM_SourceY, EDX
	dec	BP     			; Decrement loop counter
	jg	texloop

	pop	CX
	pop	BX
	pop	DI
	pop	SI
	pop	DS
	pop	BP
	retf

_ASM_TexScanLine	ENDP

_ASM_TexScanHoleLine	PROC	FAR

	push	BP
	push	DS
	push	SI
	push	DI
	push	BX
	push	CX

	mov	AX, seg _ASM_Tex
	mov	DS, AX
	lgs	SI, _ASM_Ptr		; GS:SI = screen
	lfs	DI, _ASM_Tex		; FS:DI = Texture map
	mov	Off, DI
	mov	BP, _ASM_Length		; BP = Loop counter
	mov	CL, _ASM_TexWidth	; CL = Tex map log 2n
	mov	CH, _ASM_Colour		; CH = colour of map
	mov	EDI, _ASM_StepX
	mov	EDX, _ASM_StepY

texholeloop :

	mov	EBX, _ASM_SourceX	; Normalise the X pointer
	shr	EBX, 16
	mov	EAX, _ASM_SourceY	; Normalise the Y pointer
	shr	EAX, 16
	shl	AX, CL			; Now back into Y map position
	add	BX, AX			; Use BX to index texture
	add	BX, Off			; Offset the screen of course
	mov	AL, FS:[BX]		; Get the texture pixel
	cmp	AL, 0
	jz	NextOne			; Ignore if it is zero
	add	AL, CH
	mov 	GS:[SI], AL		; write the pixel
NextOne :
	add	SI, 80			; Go to the next pixel
	add	_ASM_SourceX, EDI
	add	_ASM_SourceY, EDX
	dec	BP     			; Decrement loop counter
	jg	texholeloop

	pop	CX
	pop	BX
	pop	DI
	pop	SI
	pop	DS
	pop	BP
	retf

_ASM_TexScanHoleLine	ENDP


public C _ASM_TexScanLine
public C _ASM_TexScanHoleLine
public C _ASM_Ptr
public C _ASM_SourceX
public C _ASM_SourceY
public C _ASM_Tex
public C _ASM_StepX
public C _ASM_StepY
public C _ASM_Colour
public C _ASM_Length
public C _ASM_TexWidth

END