
//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//	V.R. CONFERENCING APPLICATION                                       //
//                                                                          //
//	Written by R.M.J.Tucker                                             //
//                                                                          //
//	(C) Copyright 1996                                                  //
//                                                                          //
//	BIRD.H								    //
//                                                                          //
//	Definition of BIRD object.	                                    //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
	
#if !defined ( __BIRD__ )
	#define __BIRD__

	#include "OBJECT\OBJECT3D.H"

	class BIRD : public OBJECT3D {

		private :

			/*	This object also has a set
				of vertices to describe it.	*/

			POINT Vertices [38];

			/*	And a set of polygons
				pointing to the vertices.	*/

			POLYGON Polygons [14];

		public :

			/*	Constructor set position and
				initial orientation of cube.	*/

			BIRD ( void );

			/*	The object should put itself
				into the viewing projection ( if 
				it wants to... ).	*/

			void Show ( VIEWPROJECTION& View );

			/*	Operation to rotate
				a wing segment.	*/

			void RotateWingSegment ( REAL Angle, POINT *v1, POINT *v2 );
	};
#endif

