
//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//	V.R. CONFERENCING APPLICATION                                       //
//                                                                          //
//	Written by R.M.J.Tucker                                             //
//                                                                          //
//	(C) Copyright 1996                                                  //
//                                                                          //
//	GROUND.H							    //
//                                                                          //
//	Definition of GROUND object.	                                    //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
	
#if !defined ( __GROUND__ )
	#define __GROUND__

	#include "OBJECT\OBJECT3D.H"
	#include "VIEW\WINDOW.H"

	class GROUND : public OBJECT3D {

		private :

			/*	Ground plane has 4 
				vertices.	*/

			#define GRIDSIZE	16

			POINT Vertices 	[GRIDSIZE][GRIDSIZE];

		public :

			/*	Constructor set position and
				initial orientation of cube.	*/

			GROUND ( void );

			/*	This object transforms itself.
				It is a special case of object.	*/

			void Show ( VIEWPROJECTION& View, GRAPHICSMODE& Buffer );

	};
#endif

