



#if !defined ( __WINDOW__ )
	#define __WINDOW__

	#include "GLOBAL\TYPES.H"
	#include "MATH\POINT.H"

	class WINDOW {

		private :

			/*	Return the clip
				code for cohen-suth.	*/

			int ClipCode ( int x, int y );

			/*	Accept a point
				inside window.	*/

			int Accept ( int a, int b );

			/*	Reject a point
				outside window.	*/

			int Reject ( int a, int b );

		public :

			/*	The dimensions of
				the window.	*/

			int Left, Top, Right, Bottom, Width, Length;

			/*	Setup the
				window.	*/

			WINDOW ( int l, int t, int r, int b );

			/*	Clip a line to
				the window.	*/

			BOOL ClipLine ( int *x1, int *y1, int *x2, int *y2 );

			/*	Return the size
				of the window.	*/

			void GetSize ( int *Width, int *Length );

			/*	Return the area
				of the window.	*/

			void GetArea ( int *Left, int *Top, int *Right, int *Bottom );
	};
#endif

