



#if !defined ( __VIEWFRUSTUM__ )
	#define __VIEWFRUSTUM__

	#include "GLOBAL\TYPES.H"

	class VIEWFRUSTUM {

		public :

			/*	The clipping frustum consists
				of distances to planes.	*/

			REAL	Distances [4];

			/*	And four normals
				to those planes.	*/

			VECTOR	Normals	  [4];


			/*	Constructor does
				nothing.	*/

			VIEWPLANE Plane ( void );

			/*	Sets up the frustum given
				the viewing conditions.	*/

			void Setup ( POINT& Observer, MATRIX& Transform, REAL Field, REAL MaxScale, REAL xScale );
	};
#endif

void VIEWFRUSTUM :: Setup ( POINT& Observer, MATRIX& Transform, REAL Field, REAL MaxScale, REAL xScale )

/*	PRE	:
	POST	:
*/

{
	REAL	Angle, Sin, Cos;
	VECTOR	vRight, vUp, vNormal;

	/*	Break out the viewing
		matrix into vectors.	*/

	Transform.Split ( vRight, vUp, vNormal );

	/*	Calculate angle to
		build the frustum.	*/

	Angle = atan ( 2.0 / Field * MaxScale / xScale );
	Sin = sin ( Angle );
	Cos = cos ( Angle );

	/*	The left clipping
		plane.	*/

	Normals [0].v [0] = Sin;
	Normals [0].v [1] = 0.0;
	Normals [0].v [2] = Cos;
	Normals [0].Rotate ( vRight, vUp, vNormal );
	Distances [0] = ( VECTOR& ) Observer.Dot ( Normals [0] );
}